<script setup lang="ts">
  import { required } from '@vuelidate/validators';
  import { useVuelidate } from '@vuelidate/core';
  import { ClientApiError } from '@shopware-pwa/types';
  import { getErrorMessages } from '~/helpers/errors';
  import { DAILY_PRIVACY_POLICY_LINK } from '~/helpers/constants';

  definePageMeta({
    layout: 'auth',
    middleware: ['presentation-pre-action'],
  });

  const localePath = useLocalePath();
  const { login, setCookieGuestAttendeeName, logout, isLoggedIn } = useUser();
  const { getVideoAndAudioSetting, mediaShouldBeUsed } = useAppointment();
  const nuxtApp = useNuxtApp();
  const router = useRouter();
  const route = useRoute();
  const isLoading = ref<boolean>();
  const loginErrorMsg = ref<string>();

  const state = reactive({
    email: '',
    password: '',
    agree: false,
  });

  const rules = {
    email: {
      required,
    },
    password: {
      required,
    },
    agree: {
      checked: (value: any) => {
        if (!mediaShouldBeUsed.value) {
          return true;
        } else {
          return value === true;
        }
      },
    },
  };

  const $v = useVuelidate(rules, state);

  onBeforeMount(async () => {
    try {
      nuxtApp.$setLoading(true);
      await removeSession();
      await getVideoAndAudioSetting();
    } finally {
      setTimeout(() => {
        nuxtApp.$setLoading(false);
      });
    }
  });

  const removeSession = async () => {
    setCookieGuestAttendeeName('');
    try {
      await logout();
    } catch (e) {}
  };

  const invokeLogin = async (e: Event) => {
    e.preventDefault();
    $v.value.$touch();
    const valid = await $v.value.$validate();
    if (valid) {
      try {
        isLoading.value = true;
        await login({
          username: state.email,
          password: state.password,
        });
        const appointmentId = route.params.appointmentId as string;
        router.push(localePath({ name: 'presentation-appointmentId', params: { appointmentId } }));
      } catch (e) {
        loginErrorMsg.value = getErrorMessages(e as ClientApiError) as string;
      } finally {
        isLoading.value = false;
      }
    }
  };

  const onChange = () => {
    loginErrorMsg.value = '';
  };

  const goToRegister = () => {
    const appointmentId = route.params.appointmentId as string;

    router.push(
      localePath({ name: 'presentation-appointmentId-register', params: { appointmentId } }),
    );
  };

  const accountForgotPasswordModalController = useModal();
</script>
<template>
  <ClientOnly>
    <div
      v-if="!isLoggedIn"
      class="min-h-100vh container mx-auto flex w-[24rem] flex-col items-center justify-center px-3"
    >
      <form
        class="flex w-full flex-col gap-6"
        autocomplete="on"
        @change="onChange"
        @submit="invokeLogin"
      >
        <div>
          <h2 class="font-bold">{{ $t('loginToJoin') }}</h2>
          <span class="text-darkgray-600 mt-2">{{ $t('loginDescription') }}</span>
        </div>
        <SwTextField
          id="email"
          v-model="state.email"
          :placeholder="$t('loginForm.emailPlaceholder')"
          name="email"
          type="email"
          :errors="$v.email.$errors"
          :label="$t('email')"
        />

        <div>
          <SwTextField
            id="password"
            v-model="state.password"
            :placeholder="$t('loginForm.passwordPlaceholder')"
            name="password"
            type="password"
            :errors="$v.password.$errors"
            :label="$t('password')"
          />

          <SwLink
            class="mt-2 block py-1 text-sm/6 font-medium"
            @click="accountForgotPasswordModalController.open"
          >
            {{ $t('forgotPassword') }}
          </SwLink>

          <AccountForgotPasswordModal
            v-if="accountForgotPasswordModalController.isOpen.value"
            :controller="accountForgotPasswordModalController"
            @back-to-login="accountForgotPasswordModalController.close"
          />
        </div>
        <SwCheckbox v-if="mediaShouldBeUsed" v-model="state.agree" :errors="$v.agree.$errors">
          <template #label>
            <i18n-t keypath="agreeTermsDailyPrivacyPolicy" :tag="false">
              <template #privacyPolicy>
                <SwLink :to="DAILY_PRIVACY_POLICY_LINK" target="_blank">
                  {{ $t('privacyPolicy') }}
                </SwLink>
              </template>
            </i18n-t>
          </template>
        </SwCheckbox>
        <SwBanner v-if="loginErrorMsg" variant="error" :show-close-btn="false">
          {{ $t(loginErrorMsg) }}
        </SwBanner>
        <div class="pt-2">
          <SwButton type="submit" :loading="isLoading" variant="primary">
            {{ $t('loginAndJoin') }}
          </SwButton>
        </div>
      </form>

      <div class="border-border mt-8 flex w-full justify-center gap-2 border-t pt-5">
        <span class="text-sm font-medium">{{ $t('noAccountYet') }}</span>
        <button class="text-(primary sm) font-medium" @click="goToRegister">
          {{ $t('createAccount') }}
        </button>
      </div>
    </div>
  </ClientOnly>
</template>
